# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::IotCentral::Mgmt::V2018_09_01
  module Models
    #
    # The IoT Central application.
    #
    class App < Resource

      include MsRestAzure

      # @return [String] The ID of the application.
      attr_accessor :application_id

      # @return [String] The display name of the application.
      attr_accessor :display_name

      # @return [String] The subdomain of the application.
      attr_accessor :subdomain

      # @return [String] The ID of the application template, which is a
      # blueprint that defines the characteristics and behaviors of an
      # application. Optional; if not specified, defaults to a blank blueprint
      # and allows the application to be defined from scratch.
      attr_accessor :template

      # @return [AppSkuInfo] A valid instance SKU.
      attr_accessor :sku


      #
      # Mapper for App class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'App',
          type: {
            name: 'Composite',
            class_name: 'App',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                constraints: {
                  Pattern: '^(?![0-9]+$)(?!-)[a-zA-Z0-9-]{2,99}[a-zA-Z0-9]$'
                },
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              location: {
                client_side_validation: true,
                required: true,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              application_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.applicationId',
                type: {
                  name: 'String'
                }
              },
              display_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.displayName',
                type: {
                  name: 'String'
                }
              },
              subdomain: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.subdomain',
                type: {
                  name: 'String'
                }
              },
              template: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.template',
                type: {
                  name: 'String'
                }
              },
              sku: {
                client_side_validation: true,
                required: true,
                serialized_name: 'sku',
                type: {
                  name: 'Composite',
                  class_name: 'AppSkuInfo'
                }
              }
            }
          }
        }
      end
    end
  end
end
